*var5
*estimate a VAR, as a preliminary to running ACQ3.PRG
*same as VAR 4,except names of variables 3rd and 4th variables in VAR are read in
environment columns=132
alloc 30 1000
clear
cal 1974 1 12
clear ius pdus yus
*
decl int ifirst last nlags ibaseyear ibasemo ilastyear ilastmo
decl real gammapi gammay gammapistar gammaystar gammapitwid gammaytwid gammaq
decl label country countryid
*no. lags in VAR, no. fundamental variables in VAR, no. of deterministict terms in VAR, start date, end date
decl int nlags nfund ndeterm ibase last
decl int ippi ipy ippistar ipystar ippitwid ipytwid ipi ipdcom
decl string junk variablename
decl vect[label] varnames
decl label yname piname
clear trend trend2
*
source detrend.prg
*
procedure var4 xy xpd xvar3 xvar4 xi xius xpicom ibegin iend nvar nlags
type series xy xpd xvar3 xvar4 xi xius xpicom
type int ibegin iend nvar
local series yunow yuus yunowus
*
set pdnowus = xpd -pdus
*
execute detrend ibegin iend nlags xy yunow yus yuus yunowus
disp $
"            yus       xy         pdus       xpd        ius      xi       xius       xpicom    pdnowus   yunowus"
copy(unit=output,org=obs,dates,format='(a10,12(f8.3,2x))') ifirst ifirst+11 $
               yus         xy         pdus         xpd           ius      xius       xi         xpicom    pdnowus   yunowus
copy(unit=output,org=obs,dates,format='(a10,12(f8.3,2x))') ibase ibase+11 $
               yus         xy         pdus         xpd           ius      xius       xi         xpicom    pdnowus   yunowus
copy(unit=output,org=obs,dates,format='(a10,12(f8.3,2x))') last-11 last $
               yus         xy         pdus         xpd           ius      xius       xi         xpicom    pdnowus   yunowus
*
comp ipd=1, iyd=2, iishock=3
if nvar .eq. 2; begin
  system
  variables pdnowus yunowus
  lags 1 to nlags
  det constant
  end(system)
end; else if nvar .eq. 3; begin
  system
  variables pdnowus yunowus xvar3
  lags 1 to nlags
  det constant
  end(system)
end; else if nvar .eq. 4; begin
  system
  variables pdnowus yunowus xvar3 xvar4
  lags 1 to nlags
  det constant
  end(system)
end
estimate(outsigma=mysigma,coeffs=mycoeffs,residual=varresid) ibase last
write(noskip) mysigma
*
open copy var5.out
disp(unit=copy) country
disp(unit=copy) "no. of obs fundamentals, no. deterministic terms, number of lags in VAR, start and end date:"
disp(unit=copy) nfund ndeterm nlags ibaseyear ibasemo ilastyear ilastmo
disp(unit=copy) "variables in VAR, variable set name: "
disp(unit=copy)  varnames
disp(unit=copy)  variablename
disp(unit=copy) "pointers for variables in VAR: ippi ipy ippistar ipystar ippitwid ipytwid"
disp(unit=copy) ippi ipy ippistar ipystar ippitwid ipytwid
disp(unit=copy) "varZe"
write(noskip,unit=copy) mysigma
comp coefftr = tr(mycoeffs)
disp(unit=copy) "phi (deterministic terms in last column(s))"
disp(unit=copy) coefftr
close copy
*
return
end
*********
****
set trend /= t
set trend2 / = t*t
open data var5.inp
*country name
read(unit=data) country
*nlags=number of lags in VAR, ibase=date of first obs in VAR, last = data of last obs
read(unit=data) nlags ndeterm
read(unit=data) junk
read(unit=data) ibaseyear ibasemo ilastyear ilastmo
read(unit=data) nfund
dim varnames(nfund)
read(unit=data) varnames
*identifier of this variable set
read(unit=data) variablename
disp varnames
comp yname = varnames(1)
comp piname = varnames(2)
close data
comp ibase=%cal(ibaseyear,ibasemo), last=%cal(ilastyear,ilastmo)
comp ifirst = ibase - 24
disp ifirst ibase last
smpl ifirst last
open data isomge.rat
if nfund .eq. 2; begin
  labels    1    2
#        yname piname
  data(format=rats) ifirst last 1 2
end; else if nfund .eq. 3; begin
  labels    1    2       3
#        yname piname varnames(3)
  data(format=rats) ifirst last 1 2 3
end; if nfund .eq. 4; begin
  labels    1    2        3          4
#        yname piname varnames(3) varnames(4)
  data(format=rats) ifirst last 1 2 3 4
end begin
end if
disp yname piname
***
decl vect[series] myresid(nfund) varresid(nfund)
comp nphi = nfund*nlags
decl vect myvect(nphi)
*
input ippi ipy ippistar ipystar ippitwid ipytwid ipi ipdcom
       0    0      0       0       1         2    0    0
data(format=rats) ifirst last yus pus ius pdus ydus pdcom
*
  comp countryid = "GE"
  data(format=rats) ifirst last ige sge pdge ydge sdge qge qdge igeus
  disp "germany"
  execute var4 1 2 3 4 ige igeus pdcom ibase last nfund nlags

close data


*
*
end
end
end
